#include<bits/stdc++.h>
using namespace std;
int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n,q;
	cin>>n>>q;
	vector<int>a(n+1),next(n+1),prev(n+1);
	vector<vector<long long>>dp(n+1,vector<long long>(20));
	for(int i=1;i<=n;i++){
		cin>>a[i];
	}
	for(int i=1;i<=n;){
		int j=i+1;
		while(j<=n&&a[i]==a[j]){
			j++;
		}
		for(int k=i;k<j;k++){
			dp[k][0]=1ll*(j-i)*a[i]*a[i];
		}
		i=j;
	}
	for(int k=1;k<20;k++){
		for(int i=1;i+(1<<k)-1<=n;i++){
			dp[i][k]=max(dp[i][k-1],dp[i+(1<<(k-1))][k-1]);
		}
	}
	auto get=[&](int l,int r){
		if(l>r){
			return 0ll;
		}
		int k=31-__builtin_clz(r-l+1);
		return max(dp[l][k],dp[r-(1<<k)+1][k]);
	};
	next[n]=n+1;
	for(int i=n-1;i>=1;i--){
		next[i]=(a[i]==a[i+1]?next[i+1]:i+1);
	}
	prev[1]=0;
	for(int i=2;i<=n;i++){
		prev[i]=(a[i]==a[i-1]?prev[i-1]:i-1);
	}
	while(q--){
		int l,r;
		cin>>l>>r;
		long long x=1ll*(next[l]-l)*a[l]*a[l];
		long long y=1ll*(r-prev[r])*a[r]*a[r];
		long long z=get(next[l],prev[r]);
		cout<<max({x,y,z})<<"\n";
	}
}